package com.unitesk.requality.eclipse;

import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.mapping.ResourceMapping;
import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.IPropertySourceProvider;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.tools.TreesTracker;
import com.unitesk.requality.eclipse.views.NodeProperty;

public class TreeNodeAdapterFactory implements IAdapterFactory {

    @SuppressWarnings("rawtypes")
    @Override
    public Object getAdapter(final Object adaptableObject, Class adapterType) {
        if (adapterType.equals(TreeNode.class)) {
            return adaptableObject;
        }
        if (adapterType.equals(IPropertySourceProvider.class)) {
            final TreeNode node = (TreeNode) adaptableObject;
            return new IPropertySourceProvider() {
                @Override
                public IPropertySource getPropertySource(Object object) {
                    return new NodeProperty(node);
                }
            };
        }

        if (adapterType.equals(IResource.class)) {
            final TreeNode node = (TreeNode) adaptableObject;
            return TreesTracker.getResourceByNode(node);
        }

        if (adapterType.equals(ResourceMapping.class)) {
            // TODO: mapping
            return null;
//            final TreeNode node = (TreeNode) adaptableObject;
//            ResourceMapping mapper = new ResourceMapping() {
//                @Override
//                public ResourceTraversal[] getTraversals(
//                        ResourceMappingContext context, IProgressMonitor monitor)
//                        throws CoreException {
//                    IFile res = (IFile) TreesTracker.getResourceByNode(node);
//                    return new ResourceTraversal[] { new ResourceTraversal(
//                            new IResource[] { res }, IResource.DEPTH_INFINITE,
//                            IResource.NONE) };
//                }
//
//                @Override
//                public IProject[] getProjects() {
//                    if (TreesTracker.getResourceByNode(node) == null) {
//                        return null;
//                    }
//                    return new IProject[] { TreesTracker
//                            .getResourceByNode(node).getProject() };
//                }
//
//                @Override
//                public String getModelProviderId() {
//                    // TODO: remove
//                    System.out.println("getModelProviderId for " + node);
//                    return RequalityModelProvider.ID;
//                }
//
//                @Override
//                public Object getModelObject() {
//                    return node;
//                }
//            };
//            return mapper;
        }

        return null;
    }

    @SuppressWarnings("rawtypes")
    @Override
    public Class[] getAdapterList() {
        return new Class[] { ResourceMapping.class, IPropertySourceProvider.class, TreeNode.class};
    }

}
