package com.unitesk.requality.eclipse.editors.browser;

import java.util.UUID;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import com.unitesk.requality.nodetypes.Document;
import com.unitesk.requality.nodetypes.Location;

final class ReqMarkerOutlineContentProvider implements
        ITreeContentProvider {

    @Override
    public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
    }

    @Override
    public void dispose() {
    }

    @Override
    public boolean hasChildren(Object element) {
        return getChildren(element).length>0;
    }

    @Override
    public Object getParent(Object element) {
        return null;
    }

    @Override
    public Object[] getElements(Object inputElement) {
        return getChildren(inputElement);
    }

    @Override
    public Object[] getChildren(Object parentElement) {
        if (parentElement instanceof Document) {
            Document doc = (Document) parentElement;
            UUID[] locationUUIDs = doc.getLocations().toArray(new UUID[0]);
            // TODO: 4checker location synchronization 
            Object[] result = new Object[locationUUIDs.length];
            for (int i = 0; i < result.length; i++) {
                result[i]=doc.getLocation(locationUUIDs[i].toString());
            }
            return result;
        }
        if (parentElement instanceof Location) {
            return new Object[]{};
        }
        return null;
    }
}