package com.unitesk.requality.eclipse.views.properties;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetPage;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetWidgetFactory;

import com.unitesk.requality.nodetypes.Requirement;

public class AdvancedPropertySection extends RequirementPropertiesTab {
    private Text textPredicate;
    private BaseRequirementPanel panelBase;

    public AdvancedPropertySection() {
    }

    @Override
    public void createControls(Composite parent,
            TabbedPropertySheetPage aTabbedPropertySheetPage) {
        super.createControls(parent, aTabbedPropertySheetPage);
        parent.setLayout(new GridLayout(1, false));
        parent.setLayoutData(new GridData(GridData.FILL_BOTH));
        TabbedPropertySheetWidgetFactory wf = aTabbedPropertySheetPage
                .getWidgetFactory();
        wf.createLabel(parent, "Predicate:");
        GridData predicateLData = new GridData(GridData.FILL_BOTH);
        predicateLData.widthHint = 0;
        predicateLData.heightHint = 0;
        textPredicate = wf.createText(parent, "true", SWT.BORDER | SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);
        textPredicate.setLayoutData(predicateLData);
        textPredicate.addFocusListener(new FocusAdapter() {
            public void focusLost(FocusEvent e) {
                req.setPredicate(textPredicate.getText());
                req.saveAttributes();
            }
        });
        panelBase = new BaseRequirementPanel(parent, this, aTabbedPropertySheetPage);
    }

    @Override
    protected void setRequirement(Requirement req) {
        if(textPredicate==null || textPredicate.isDisposed()) {
            return;
        }
        textPredicate.setText(req.getPredicate());
        panelBase.setRequirement(req);
    }
}
