package com.unitesk.requality.merge;

import java.io.Writer;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;

public class Utils {
    
    public static void writeXmlFile(Document doc, Writer output) {
	try {
	    Source source = new DOMSource(doc);

	    Result result = new StreamResult(output);

	    Transformer xformer = TransformerFactory.newInstance()
		    .newTransformer();
	    xformer.transform(source, result);
	} catch (TransformerConfigurationException e) {
	} catch (TransformerException e) {
	}
    }
    
    public static double jaccardSimilarity(String a, String b) {
	String[] tokens1 = a.split("[ \t\n\r\f]+");
	String[] tokens2 = b.split("[ \t\n\r\f]+");
	List<String> aTokens = new LinkedList<String>(Arrays.asList(tokens1));
	List<String> bTokens = new LinkedList<String>(Arrays.asList(tokens2));
	int commonTokens = 0;
	ListIterator<String> i = aTokens.listIterator();
	while (i.hasNext()) {
	    String refToken = i.next();
	    ListIterator<String> j = bTokens.listIterator();
	    while (j.hasNext()) {
		String currToken = j.next();
		if (refToken.equals(currToken)) {
		    commonTokens++;
		    i.remove();
		    j.remove();
		    break;
		}
	    }
	}
	int diff = tokens1.length + tokens2.length - commonTokens;
	if (diff == 0)
	    return 0;
	else
	    return (double) commonTokens / diff;
    }
    
    public static double nonSymmetricSimilarity(String match, String reference) {
	String[] tokens1 = match.split("[ \t\n\r\f]+");
	String[] tokens2 = reference.split("[ \t\n\r\f]+");
	List<String> matchTokens = new LinkedList<String>(Arrays.asList(tokens1));
	List<String> referenceTokens = new LinkedList<String>(Arrays.asList(tokens2));
	int commonTokens = 0;
	ListIterator<String> i = matchTokens.listIterator();
	while (i.hasNext()) {
	    String t1 = i.next();
	    ListIterator<String> j = referenceTokens.listIterator();
	    while (j.hasNext()) {
		String t2 = j.next();
		if (t1.equals(t2)) {
		    commonTokens++;
		    i.remove();
		    j.remove();
		    break;
		}
	    }
	}
	int diff = 2*tokens1.length - commonTokens;
	if (diff == 0)
	    return 0;
	else
	    return (double) commonTokens / diff;
    }
}
