package com.unitesk.requality.report;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;

public class TemplateFile {
    private IReportDataSource dataObject;
    private String templatePath;
    private String outputFile;
    private String dataClass;
    private String reportPath;

    public TemplateFile(String reportPath, String templatePath, String outputFile,
            String dataClass) {
        super();
        this.reportPath = reportPath;
        this.templatePath = templatePath;
        this.outputFile = outputFile;
        this.dataClass = dataClass;
    }

    public String getDataClass() {
        return dataClass;
    }

    public String getTemplatePath() {
        return templatePath;
    }

    public String getOutputFileName() {
        return outputFile;
    }

    public IReportDataSource instanceDataObject()
            throws InstantiationException, IllegalAccessException, ClassNotFoundException {
        return instanceDataObject(ClassLoader.getSystemClassLoader());
    }

    public IReportDataSource instanceDataObject(ClassLoader baseClassLoader)
            throws InstantiationException, IllegalAccessException,
            ClassNotFoundException {
        if(dataObject!=null) {
            return dataObject;
        }
        URL classPaths[] = null;
        try {
            classPaths = new URL[] { new File(reportPath + File.separator
                    + "classes").toURI().toURL() };
        } catch (MalformedURLException e) {
            e.printStackTrace();
        }

        URLClassLoader cl = URLClassLoader.newInstance(classPaths, baseClassLoader);
        @SuppressWarnings("unchecked")
        Class<IReportDataSource> ds = (Class<IReportDataSource>) cl
                .loadClass(getDataClass());
        dataObject = ds.newInstance();
        return dataObject;
    }

    public void setDataObject(IReportDataSource dataObject) {
        this.dataObject = dataObject;
    }
}
